#ifndef LEXER_H
#define LEXER_H

#include <stdint.h>

#define SmallBuffSize 255

class Lexer {
public:
    enum Token {kToken__End = 0, kToken__Invalid,
               kToken_SCol, kToken_Comma, kToken_Col, kToken_Hash,
               kToken_Class, kToken_ShwMod, //private, etc.
               kToken_Virtual, kToken_Friend, kToken_Typedef,
               kToken_Const, kToken_False, kToken_True,
               kToken_LParen, kToken_RParen, kToken_LBrace, kToken_RBrace, kToken_LBracket, kToken_RBracket,
               kToken_Ident, kToken_Int,
               kToken_Binary, kToken_Unary,
               kToken_Prag};
private:
    char*   mSource;
    char*   mCurr;
    char*   mHelper;

    char    mSmallBuff[SmallBuffSize+1];
    char*   mBigBuff;
    char*   mBuff;
    long    mBigBuffSize;

    uint8_t mPr;

    bool    mEnd;
public:
    Lexer(char*);
    ~Lexer();

    Token next();
    const char* ident();
};

#endif // LEXER_H
