#include <list>
#include <string>
#include <map>
#include <fcntl.h>
#include <ctype.h>
#include <fstream>
#include "lexer.h"
#include <string.h>
#include <iostream>
#include <sstream>
#include <set>


std::string parr[] = {"sal_Int8","sal_Int16","sal_Int32",
                             "sal_uInt8","sal_uInt16","sal_uInt32",
                              "sal_Bool", "bool", "int", "unsigned int",
                      "signed int"/*, "SwCharCompressType"*/};
std::set<std::string> pset(parr, parr+(sizeof(parr)/sizeof(std::string)));

std::list<std::string> ns;
std::string parent;
std::string pclass;
struct methodT {
    std::list<std::string> mods;
    std::string name;
    std::list<std::string> head;
    std::list<std::string> args;
    std::list<std::string> mods2;
    methodT() {}
};
std::list<methodT> methods;
uint32_t bstack = 0;

std::string cMod = "private:";

std::list<std::string> tl;

void parse();
void generate(std::string, std::string, std::string);

char* buff;
Lexer* lex;

int main(int argc, char* argv[])
{
    long len;
    FILE* f;
    argv[1] = "doc.hxx";
    f = fopen(argv[1], "r");
    fseek(f, 0, SEEK_END);
    len = ftell(f);
    fseek(f, 0, SEEK_SET);
    buff = new char[len+1];
    fread(buff, 1, len, f);
    fclose(f);

    lex = new Lexer(buff);

    parse();

    delete lex;
    delete buff;
/*
    uint32_t nl = strlen(argv[1]);
    argv[1][nl-4] = 0;
    std::string hxxName = argv[1];
    hxxName+="Stub";
    std::string cxxName = argv[1];
    cxxName+="Stub";

    argv[1][nl-4] = '.';
    generate(argv[1], hxxName, cxxName);*/
    generate(argv[1],"docStub", "docStub");
    return 0;
}

void parse() {
    Lexer::Token c;
    Lexer::Token d;
    do {
        d = lex->next();
        while(d != Lexer::kToken_Class) {
            if(d == Lexer::kToken_Ident) {
                if(!strcmp(lex->ident(), "namespace")||
                        !strcmp(lex->ident(), "struct")) {
                    lex->next();
                    std::string name = lex->ident();
                    d = lex->next();
                    if(d == Lexer::kToken_LParen) {
                        ns.push_back(name);
                    }
                }
            } else if(d == Lexer::kToken_LParen) {
                ns.push_back("");//???
            } else if(d == Lexer::kToken_RParen) {
                ns.pop_back();
            }
            d = lex->next();
        }

        lex->next();
        if(!strcmp(lex->ident(), ">")) continue;
        pclass = lex->ident();
        c = lex->next();
        while(c == Lexer::kToken_Ident) {
            pclass = lex->ident();
            c = lex->next();
        }
    } while(c == Lexer::kToken_SCol);
    parent = "";
    for(std::list<std::string>::iterator it = ns.begin(); it != ns.end(); it++)  {
        if(it != ns.begin()) parent += "::";
        parent += *it;
    }
    //parent += pclass;
    while(lex->next() != Lexer::kToken_LBrace);
    c = lex->next();
    bstack++;
    while(bstack && c) {
        if(c == Lexer::kToken_ShwMod) {
            cMod = lex->ident();
            cMod.push_back(':');
            lex->next();
            c = lex->next();
        } else if(c == Lexer::kToken_Col) {
            c = lex->next();
            if(c == Lexer::kToken_Col) {
                c = lex->next();
                if(c == Lexer::kToken_Ident) {
                   tl.push_back("::");
                   tl.push_back(lex->ident());
                   c = lex->next();
                   goto method1;
                }
            }
        } else if(bstack == 1 && (c == Lexer::kToken_Ident  || !strcmp(lex->ident(), "~"))) {//maybe a method declaration?
            method1:
            while(c == Lexer::kToken_Ident || c == Lexer::kToken_Col ||
                  !strcmp(lex->ident(), "<") || !strcmp(lex->ident(), ">") ||
                    !strcmp(lex->ident(), "*") || !strcmp(lex->ident(), "&") || !strcmp(lex->ident(), "~")) {
                tl.push_back(lex->ident());
                c = lex->next();
            }
            if(tl.back() == "operator") {
                if(c == Lexer::kToken_LParen) {
                     lex->next();
                    c = lex->next();
                    tl.back()+="()";
                } else {
                    while(c != Lexer::kToken_LParen) {
                        tl.back()+=lex->ident();
                        c = lex->next();
                    }
                }
            }
            if(c == Lexer::kToken_LParen) { //OMG yappari a method!
                std::string method = tl.back();
                if(method == "GetNodes") {
                    std::cout << "";
                }
                tl.pop_back();
                if(tl.back() == "~") {
                    method = "~"+method;
                    tl.pop_back();
                }
                methods.push_back(methodT());
                methods.back().mods = tl;
                methods.back().mods.push_front(cMod + " ");
                methods.back().name = method;
                tl.clear();
                c = lex->next();
                bool def = false;
                int templ = 0;
                uint32_t count = 0;
                if(c != Lexer::kToken_RParen) methods.back().args.push_back("");
                while(c != Lexer::kToken_RParen) {
                    if(c == Lexer::kToken_Comma) {
                        if(count < 2) {
                            char ib[4];
                            uint8_t idx = 0;
                            again1:
                                idx++;
                                methods.back().args.back() = "arg";
                                sprintf(ib,"%d",idx);
                                methods.back().args.back()+=ib;
                                for(std::list<std::string>::iterator it = methods.back().args.begin();
                                    it != --methods.back().args.end();it++) if(*it == methods.back().args.back()) goto again1;
                            methods.back().head.push_back(methods.back().args.back());
                        }
                        methods.back().args.push_back("");
                        def = false;
                        count = 0;
                    } else if(c == Lexer::kToken_Ident && !def && !templ) {
                        if(strcmp(lex->ident(), "const")) {
                            std::list<std::string>::reverse_iterator hit = methods.back().head.rbegin();
                            if(methods.back().head.size() > 1) {
                                if(*hit == ":" && *(++hit) == ":") {
                                    if(methods.back().head.size() == 2) {
                                        count++;
                                    } else if(methods.back().head.size() > 2 && (*(++hit) == ","|| *hit == "const")) {
                                        count++;
                                    }
                                } else {
                                    count++;
                                }
                            } else {
                                count++;
                            }
                            methods.back().args.back() = lex->ident();
                        }
                    } else if(!strcmp(lex->ident(), "=")) {
                        def = true;
                        if(count < 2) {
                            char ib[4];
                            uint8_t idx = 0;
                            again2:
                                idx++;
                                methods.back().args.back() = "arg";
                                sprintf(ib,"%d",idx);
                                methods.back().args.back()+=ib;
                                for(std::list<std::string>::iterator it = methods.back().args.begin();
                                    it != --methods.back().args.end();it++) if(*it == methods.back().args.back()) goto again2;
                            methods.back().head.push_back(methods.back().args.back());
                        }
                        count++;
                    } else if(!strcmp(lex->ident(), "<")) templ++;
                    else if(!strcmp(lex->ident(), ">")) templ--;
                    methods.back().head.push_back(lex->ident());
                    c = lex->next();
                }
                if(count < 2 && !methods.back().args.empty()) {
                    char ib[4];
                    uint8_t idx = 0;
                    again3:
                        idx++;
                        methods.back().args.back() = "arg";
                        sprintf(ib,"%d",idx);
                        methods.back().args.back()+=ib;
                        for(std::list<std::string>::iterator it = methods.back().args.begin();
                            it != --methods.back().args.end();it++) if(*it == methods.back().args.back()) goto again3;
                    methods.back().head.push_back(methods.back().args.back());
                }
                c= lex->next();
                while(c != Lexer::kToken_LBrace && c != Lexer::kToken_SCol) {
                    methods.back().mods2.push_back(lex->ident());
                    c = lex->next();
                }
                if(c == Lexer::kToken_LBrace) {
                    uint32_t cstack = bstack;
                    cstack++;
                    c = lex->next();
                    while(cstack > bstack) {
                        if(c == Lexer::kToken_LBrace) cstack++;
                        else if(c == Lexer::kToken_RBrace) cstack--;
                        c = lex->next();
                      }
                } else c = lex->next();
            } else { //not a method :(
                tl.clear();
                //c = lex->next();
            }
        } /*else if(c == Lexer::kToken_Typedef) { //emit typedef
            while(lex->next() != Lexer::kToken_LBrace);
            uint32_t cstack = bstack+1;
            while(cstack > bstack) {
                c = lex->next();
                if(c == Lexer::kToken_LBrace) cstack++;
                else if(c == Lexer::kToken_RBrace) cstack--;
            }
            c = lex->next();
         } */else if(c == Lexer::kToken_LBrace) {
            bstack++;
            c = lex->next();
        } else if(c == Lexer::kToken_RBrace){
            bstack--;
            c = lex->next();
        } else {
            c = lex->next();
        }
    }
}

void generate(std::string head, std::string hxx, std::string cxx) {
    std::ofstream h;
    std::stringstream ss;
    std::set<std::string> typeset;
    h.open((hxx+".hxx").c_str());
    h << "#ifndef " << hxx << "_HXX\n";
    h << "#define " << hxx << "_HXX\n";
    h << "#include \"" << head << "\"\n";
    if(!parent.empty()) h << "using namespace " << parent << ";\n";
    h << "class " << pclass << "Stub : public " << parent << ((!parent.empty())?"::":"")<< pclass << " {\n";
    for(std::list<methodT>::iterator it = methods.begin(); it != methods.end(); it++) {
        if(it->name == "DECL_LINK" || it->name == "DECL_STATIC_LINK") continue;
        if(*(++it->mods.begin()) != "virtual") continue;
        ss.str("");
        for(std::list<std::string>::iterator lit = it->mods.begin(); lit != it->mods.end(); lit++) {
            h << *lit;
            std::list<std::string>::iterator lit2 = lit;
            lit2++;
            if(!(lit2 != it->mods.end() && *lit == ":" && *lit2 == ":")) h << " ";
        }
        h << " " << it->name;
        if(it->name == pclass || it->name == "~"+pclass) h << "Stub";
        h << "(";
        for(std::list<std::string>::iterator lit = it->head.begin(); lit != it->head.end(); lit++) {
            h << *lit;
            std::list<std::string>::iterator lit2 = lit;
            lit2++;
            if(!(lit2 != it->mods.end() && *lit == ":" && *lit2 == ":")) h << " ";
        }
        h << ")";
        for(std::list<std::string>::iterator lit = it->mods2.begin(); lit != it->mods2.end(); lit++) {
            h << *lit;
            std::list<std::string>::iterator lit2 = lit;
            lit2++;
            if(!(lit2 != it->mods.end() && *lit == ":" && *lit2 == ":")) h << " ";
        }

        h << ";\n";
    }
    h << "};\n";
    h << "#endif\n";
    h.close();

    //===================================================================================//

    h.open((cxx+".cxx").c_str());
    h << "#include <" << hxx << ".hxx>\n";
    h << "#include <iostream>\n";
    if(!parent.empty()) h << "using namespace " << parent << ";\n";
    for(std::list<methodT>::iterator it = methods.begin(); it != methods.end(); it++) {
        if(it->name == "DECL_LINK" || it->name == "DECL_STATIC_LINK") continue;
        if(*(++it->mods.begin()) != "virtual") continue;
        for(std::list<std::string>::iterator lit = ++++it->mods.begin(); lit != it->mods.end(); lit++) {
            h << *lit;
            std::list<std::string>::iterator lit2 = lit;
            lit2++;
            if(!(lit2 != it->mods.end() && *lit == ":" && *lit2 == ":")) h << " ";
        }
        h << " " << pclass << "Stub::" << it->name;
        if(it->name == pclass || it->name == "~"+pclass) h << "Stub";
        h << "(";
        for(std::list<std::string>::iterator lit = it->head.begin(); lit != it->head.end(); lit++) {
            if(*lit == "=") while(lit != it->head.end() && *lit != ",") lit++;
            if(lit == it->head.end()) break;
            h << *lit;
            std::list<std::string>::iterator lit2 = lit;
            lit2++;
            if(!(lit2 != it->mods.end() && *lit == ":" && *lit2 == ":")) h << " ";
        }
        h << ")";
        for(std::list<std::string>::iterator lit = it->mods2.begin(); lit != it->mods2.end(); lit++) {
            h << *lit;
            std::list<std::string>::iterator lit2 = lit;
            lit2++;
            if(!(lit2 != it->mods.end() && *lit == ":" && *lit2 == ":")) h << " ";
        }

        h << " {\n";

        h<< "std::cout << \"" << it->name << "\" << \"(\"";
        std::list<std::string>::iterator sit = it->head.begin();
        for(std::list<std::string>::iterator lit = it->args.begin(); lit != it->args.end(); lit++) {
            ss.str("");
            for(; sit != it->head.end() && *sit != *lit; sit++) {
                if(*sit == "void" || *sit == "const") continue;
                ss << *sit;
            }
            while(sit != it->head.end() && *sit != ",") sit++;
            if(sit != it->head.end() && *sit == ",") sit++;
            if(lit != it->args.begin())h << " << \",\"";
            std::string type = "";
            if(ss.str() != "") {
                if(*ss.str().rbegin() == '&') type = ss.str().substr(0, ss.str().length()-1);
                else type = ss.str();
            }
            //std::cout << type << "\n";
            if(pset.find(type) == pset.end() && *ss.str().rbegin() != '*') h << "<< \"" << *lit << "\"";
            else h << " << " << *lit;
        }
        h << " << \")\\n\";\n";

        std::stringstream t;
        for(std::list<std::string>::iterator lit = ++++it->mods.begin(); lit != it->mods.end(); lit++) {
            if(*lit == "void" || *lit == "" || *lit == "const") continue;
            t << *lit;
        }
        //for now:
        goto useparent;

        if(*it->mods.rbegin() == "*") {
            h << "return NULL;\n";
        } else if(*it->mods.rbegin() == "&") {
            if(*(++it->mods.rbegin()) == "*") {
                h << t.str() << " out = ";
                h << "NULL;\n";
            } else if(pset.find(t.str().substr(0, t.str().length()-1) ) != pset.end()) {
                h << t.str() << " out = ";
                h << "0;\n";
            } else {
                goto useparent;
            }
            h << "return out;\n";
        } else if(pset.find(t.str()) != pset.end()) {
            h << "return 0;\n";
        } else {
            useparent:
            //if(t.str() != "") {
                h << "return " << parent << ((!parent.empty())?"::":"") << pclass <<  "::" << it->name;
                h << "(";
                for(std::list<std::string>::iterator lit = it->args.begin(); lit != it->args.end(); lit++) {
                    if(*lit == "void" || *lit == "") continue;
                    if(lit != it->args.begin()) h << ", ";
                    h << *lit;
                }
                h << ");\n";
            //}
        }
        h << "}\n\n";
    }
    h.close();
}
